/*
  Simple MPI program that demonstrates collective communication

  Jim Teresco
  Department of Computer Science
  Williams College

  Created: Fall 2000

  Last Modification:
  Mon Mar  3 21:55:57 EST 2003

  $Id$
*/

#include <stdio.h>
#include <mpi.h>

int main(int argc, char *argv[]) {
  int rc;
  int mypid, myval;
  int sum, prod, max, min;

  rc = MPI_Init(&argc,&argv);
  if (rc != MPI_SUCCESS) {
    fprintf(stderr,"Cannot initialize MPI\n");
    MPI_Abort(MPI_COMM_WORLD, 1);
  }

  MPI_Comm_rank(MPI_COMM_WORLD,&mypid);
  myval=mypid+1;

  MPI_Reduce(&myval,&sum,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
  MPI_Reduce(&myval,&prod,1,MPI_INT,MPI_PROD,0,MPI_COMM_WORLD);
  MPI_Reduce(&myval,&min,1,MPI_INT,MPI_MIN,0,MPI_COMM_WORLD);
  MPI_Reduce(&myval,&max,1,MPI_INT,MPI_MAX,0,MPI_COMM_WORLD);

  if (mypid == 0) {
    printf("Reduce values: sum %d proc %d min %d max %d\n",sum,prod,min,max);
  }

  MPI_Finalize();
}

